;compiled by SIMPLE version 2.02
;rem Test the simple2 compiler's comparisons 11/9/12
;rem bitset bitclear bitcopy shift left/right loop if/then/else/endif and
;rem other common operations already tested in the blink.sim example.
;rem This program focuses on attempting to test all forms of comparisons...
;rem if var1 = var2 goto label
;rem if var1 < var2 goto label
;rem if var1 > var2 goto label
;rem if var1 <= var2 goto label
;rem if var1 >= var2 goto label
;rem if var1 <> var2 goto label
;rem if var1 = number goto label
;rem if var1 < number goto label
;rem if var1 > number goto label
;rem if var1 <= number goto label
;rem if var1 >= number goto label
;rem if var1 <> number goto label
;rem if var1 = var2 then
;rem if var1 < var2 then
;rem if var1 > var2 then
;rem if var1 <= var2 then
;rem if var1 >= var2 then
;rem if var1 <> var2 then
;rem if var1 = number then
;rem if var1 < number then
;rem if var1 > number then
;rem if var1 <= number then
;rem if var1 >= number then
;rem if var1 <> number then
;rem ...each test done with enough inputs to show correctness
;rem If pass then GPIO bit 0 is set high, otherwise low if error.
;rem Note... 100% coverage not guaranteed, writing test code is not easy...

;rem assembler-specific directives
 list p=12f675
 radix dec
 include <p12f675.inc>
 __CONFIG _WDT_OFF & _MCLRE_OFF & _PWRTE_ON & _CP_OFF & _CPD_OFF & _INTRC_OSC_NOCLKOUT
 errorlevel -302 

#define hiregs STATUS,RP0 ;for banking
#define pindirs 00000000B ;all outputs
#define outpin GPIO,0 ;output pin

;rambase 32
var1 EQU 0x20
var2 EQU 0x21

 GOTO start ;jump to actual start
 ORG 8

start ;start of program code
;GPIO = 0
 CLRF GPIO
;INTCON = 0
 CLRF INTCON
;ADCON0 = 0
 CLRF ADCON0
;T1CON = 0
 CLRF T1CON
;CMCON = 7
 MOVLW 7
 MOVWF CMCON
;bitset hiregs
 BSF hiregs
;ANSEL = 0
 CLRF ANSEL
;PIE1 = 0
 CLRF PIE1
;WPU = 0
 CLRF WPU
;IOC = 0
 CLRF IOC
;OPTION_REG = 11001101B
 MOVLW 11001101B
 MOVWF OPTION_REG
;TRISIO = #pindirs
 MOVLW pindirs
 MOVWF TRISIO
;bitclear hiregs
 BCF hiregs

;rem if var1 = var2 goto label
;var1 = 20
 MOVLW 20
 MOVWF var1
;var2 = 21
 MOVLW 21
 MOVWF var2
;if var1 = var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,2
 GOTO hang
;var1 = 20
 MOVLW 20
 MOVWF var1
;var2 = 20
 MOVLW 20
 MOVWF var2
;if var1 = var2 goto veqok
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,2
 GOTO veqok
 GOTO hang
veqok

;rem if var1 < var2 goto label
;var1 = 30
 MOVLW 30
 MOVWF var1
;var2 = 30
 MOVLW 30
 MOVWF var2
;if var1 < var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO hang
;var1 = 31
 MOVLW 31
 MOVWF var1
;var2 = 30
 MOVLW 30
 MOVWF var2
;if var1 < var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO hang
;var1 = 30
 MOVLW 30
 MOVWF var1
;var2 = 31
 MOVLW 31
 MOVWF var2
;if var1 < var2 goto vltok
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO vltok
 GOTO hang
vltok

;rem if var1 > var2 goto label
;var1 = 30
 MOVLW 30
 MOVWF var1
;var2 = 30
 MOVLW 30
 MOVWF var2
;if var1 > var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO hang
;var1 = 30
 MOVLW 30
 MOVWF var1
;var2 = 31
 MOVLW 31
 MOVWF var2
;if var1 > var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO hang
;var1 = 31
 MOVLW 31
 MOVWF var1
;var2 = 30
 MOVLW 30
 MOVWF var2
;if var1 > var2 goto vgtok
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO vgtok
 GOTO hang
vgtok

;rem if var1 <= var2 goto label
;var1 = 51
 MOVLW 51
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 <= var2 goto hang
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO hang
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 <= var2 goto vlteok1
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO vlteok1
 GOTO hang
vlteok1
;var1 = 49
 MOVLW 49
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 <= var2 goto vlteok2
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO vlteok2
 GOTO hang
vlteok2

;rem if var1 >= var2 goto label
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 51
 MOVLW 51
 MOVWF var2
;if var1 >= var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO hang
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 >= var2 goto vgteok1
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO vgteok1
 GOTO hang
vgteok1
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 49
 MOVLW 49
 MOVWF var2
;if var1 >= var2 goto vgteok2
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO vgteok2
 GOTO hang
vgteok2

;rem if var1 <> var2 goto label
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 <> var2 goto hang
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,2
 GOTO hang
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 51
 MOVLW 51
 MOVWF var2
;if var1 <> var2 goto vneok
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,2
 GOTO vneok
 GOTO hang
vneok

;rem if var1 = number goto label
;var1 = 30
 MOVLW 30
 MOVWF var1
;if var1 = 31 goto hang
 MOVLW 31
 SUBWF var1,0
 BTFSC 3,2
 GOTO hang
;var1 = 30
 MOVLW 30
 MOVWF var1
;if var1 = 29 goto hang
 MOVLW 29
 SUBWF var1,0
 BTFSC 3,2
 GOTO hang
;var1 = 30
 MOVLW 30
 MOVWF var1
;if var1 = 30 goto ceqok
 MOVLW 30
 SUBWF var1,0
 BTFSC 3,2
 GOTO ceqok
 GOTO hang
ceqok

;rem if var1 < number goto label
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 < 40 goto hang
 MOVLW 40
 SUBWF var1,0
 BTFSS 3,0
 GOTO hang
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 < 39 goto hang
 MOVLW 39
 SUBWF var1,0
 BTFSS 3,0
 GOTO hang
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 < 41 goto cltok
 MOVLW 41
 SUBWF var1,0
 BTFSS 3,0
 GOTO cltok
 GOTO hang
cltok

;rem if var1 > number goto label
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 > 40 goto hang
 MOVLW 40^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO hang
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 > 41 goto hang
 MOVLW 41^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO hang
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 > 39 goto cgtok
 MOVLW 39^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO cgtok
 GOTO hang
cgtok

;rem if var1 <= number goto label
;var1 = 20
 MOVLW 20
 MOVWF var1
;if var1 <= 19 goto hang
 MOVLW 19^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO hang
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 <= 40 goto clteok1
 MOVLW 40^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO clteok1
 GOTO hang
clteok1
;var1 = 39
 MOVLW 39
 MOVWF var1
;if var1 <= 40 goto clteok2
 MOVLW 40^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO clteok2
 GOTO hang
clteok2

;rem if var1 >= number goto label
;var1 = 20
 MOVLW 20
 MOVWF var1
;if var1 >= 21 goto hang
 MOVLW 21
 SUBWF var1,0
 BTFSC 3,0
 GOTO hang
;var1 = 40
 MOVLW 40
 MOVWF var1
;if var1 >= 40 goto cgteok1
 MOVLW 40
 SUBWF var1,0
 BTFSC 3,0
 GOTO cgteok1
 GOTO hang
cgteok1
;var1 = 39
 MOVLW 39
 MOVWF var1
;if var1 >= 38 goto cgteok2
 MOVLW 38
 SUBWF var1,0
 BTFSC 3,0
 GOTO cgteok2
 GOTO hang
cgteok2

;rem if var1 <> number goto label
;var1 = 50
 MOVLW 50
 MOVWF var1
;if var1 <> 50 goto hang
 MOVLW 50
 SUBWF var1,0
 BTFSS 3,2
 GOTO hang
;var1 = 49
 MOVLW 49
 MOVWF var1
;if var1 <> 50 goto cneok
 MOVLW 50
 SUBWF var1,0
 BTFSS 3,2
 GOTO cneok
 GOTO hang
cneok

;rem do if/then checks... for these don't reset the variables each time

;rem if var1 = var2 then
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 51
 MOVLW 51
 MOVWF var2
;if var1 = var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,2
 GOTO ifnext__10
 GOTO hang
;else
 GOTO ifend__10
ifnext__10
; var2 = 50
 MOVLW 50
 MOVWF var2
; if var1 = var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,2
 GOTO ifnext__20
 GOTO vteqok
; endif
ifnext__20
;endif
ifend__10
 GOTO hang
vteqok

;rem if var1 < var2 then
;var1 = 60
 MOVLW 60
 MOVWF var1
;var2 = 60
 MOVLW 60
 MOVWF var2
;if var1 < var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__11
 GOTO hang
;else
 GOTO ifend__11
ifnext__11
; var1 = 61
 MOVLW 61
 MOVWF var1
; if var1 < var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__21
 GOTO hang
; else
 GOTO ifend__21
ifnext__21
;  var1 = 59
 MOVLW 59
 MOVWF var1
;  if var1 < var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__30
 GOTO vtltok
;  endif
ifnext__30
; endif
ifend__21
;endif
ifend__11
 GOTO hang
vtltok

;rem if var1 > var2 then
;var1 = 60
 MOVLW 60
 MOVWF var1
;var2 = 60
 MOVLW 60
 MOVWF var2
;if var1 > var2 then
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO ifnext__12
 GOTO hang
;else
 GOTO ifend__12
ifnext__12
; var1 = 59
 MOVLW 59
 MOVWF var1
; if var1 > var2 then
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO ifnext__22
 GOTO hang
; else
 GOTO ifend__22
ifnext__22
;  var1 = 61
 MOVLW 61
 MOVWF var1
;  if var1 > var2 then
 MOVF var1,0
 SUBWF var2,0
 BTFSC 3,0
 GOTO ifnext__31
 GOTO vtgtok
;  endif
ifnext__31
; endif
ifend__22
;endif
ifend__12
 GOTO hang
vtgtok

;rem if var1 <= var2 then
;var1 = 61
 MOVLW 61
 MOVWF var1
;var2 = 60
 MOVLW 60
 MOVWF var2
;if var1 <= var2 then
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO ifnext__13
 GOTO hang
;else
 GOTO ifend__13
ifnext__13
; var1 = 60
 MOVLW 60
 MOVWF var1
; if var1 <= var2 then
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO ifnext__23
;  var1 = 59
 MOVLW 59
 MOVWF var1
;  if var1 <= var2 then
 MOVF var1,0
 SUBWF var2,0
 BTFSS 3,0
 GOTO ifnext__32
 GOTO vtlteok
;  endif
ifnext__32
; endif
ifnext__23
;endif
ifend__13
 GOTO hang
vtlteok

;rem if var1 >= var2 then
;var1 = 60
 MOVLW 60
 MOVWF var1
;var2 = 61
 MOVLW 61
 MOVWF var2
;if var1 >= var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO ifnext__14
 GOTO hang
;else
 GOTO ifend__14
ifnext__14
; var1 = 61
 MOVLW 61
 MOVWF var1
; if var1 >= var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO ifnext__24
;  var1 = 62
 MOVLW 62
 MOVWF var1
;  if var1 >= var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,0
 GOTO ifnext__33
 GOTO vtgteok
;  endif
ifnext__33
; endif
ifnext__24
;endif
ifend__14
 GOTO hang
vtgteok

;rem if var1 <> var2 then
;var1 = 50
 MOVLW 50
 MOVWF var1
;var2 = 50
 MOVLW 50
 MOVWF var2
;if var1 <> var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSC 3,2
 GOTO ifnext__15
 GOTO hang
;else
 GOTO ifend__15
ifnext__15
; if var1 = var2 then
 MOVF var2,0
 SUBWF var1,0
 BTFSS 3,2
 GOTO ifnext__25
 GOTO vtneok
; endif
ifnext__25
;endif
ifend__15
 GOTO hang
vtneok

;rem if var1 = number then
;var1 = 25
 MOVLW 25
 MOVWF var1
;if var1 = 26 then
 MOVLW 26
 SUBWF var1,0
 BTFSS 3,2
 GOTO ifnext__16
 GOTO hang
;else
 GOTO ifend__16
ifnext__16
; if var1 = 25 then
 MOVLW 25
 SUBWF var1,0
 BTFSS 3,2
 GOTO ifnext__26
 GOTO cteqok
; endif
ifnext__26
;endif
ifend__16
 GOTO hang
cteqok

;rem if var1 < number then
;var1 = 35
 MOVLW 35
 MOVWF var1
;if var1 < 35 then
 MOVLW 35
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__17
 GOTO hang
;else
 GOTO ifend__17
ifnext__17
; if var1 < 34 then
 MOVLW 34
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__27
 GOTO hang
; else
 GOTO ifend__27
ifnext__27
;  if var1 < 36 then
 MOVLW 36
 SUBWF var1,0
 BTFSC 3,0
 GOTO ifnext__34
 GOTO ctltok
;  endif
ifnext__34
; endif
ifend__27
;endif
ifend__17
 GOTO hang
ctltok

;rem if var1 > number then
;var1 = 35
 MOVLW 35
 MOVWF var1
;if var1 > 35 then
 MOVLW 35^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO ifnext__18
 GOTO hang
;else
 GOTO ifend__18
ifnext__18
; if var1 > 36 then
 MOVLW 36^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO ifnext__28
 GOTO hang
; else
 GOTO ifend__28
ifnext__28
;  if var1 > 34 then
 MOVLW 34^0xFF
 ADDWF var1,0
 BTFSS 3,0
 GOTO ifnext__35
 GOTO ctgtok
;  endif
ifnext__35
; endif
ifend__28
;endif
ifend__18
 GOTO hang
ctgtok

;rem if var1 <= number then
;var1 = 50
 MOVLW 50
 MOVWF var1
;if var1 <= 49 then
 MOVLW 49^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO ifnext__19
 GOTO hang
;else
 GOTO ifend__19
ifnext__19
; if var1 <= 50 then
 MOVLW 50^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO ifnext__29
;  if var1 <= 51 then
 MOVLW 51^0xFF
 ADDWF var1,0
 BTFSC 3,0
 GOTO ifnext__36
 GOTO ctlteok
;  endif
ifnext__36
; endif
ifnext__29
;endif
ifend__19
 GOTO hang
ctlteok

;rem if var1 >= number then
;var1 = 50
 MOVLW 50
 MOVWF var1
;if var1 >= 51 then
 MOVLW 51
 SUBWF var1,0
 BTFSS 3,0
 GOTO ifnext__110
 GOTO hang
;else
 GOTO ifend__110
ifnext__110
; if var1 >= 50 then
 MOVLW 50
 SUBWF var1,0
 BTFSS 3,0
 GOTO ifnext__210
;  if var1 >= 49 then
 MOVLW 49
 SUBWF var1,0
 BTFSS 3,0
 GOTO ifnext__37
 GOTO ctgteok
;  endif
ifnext__37
; endif
ifnext__210
;endif
ifend__110
 GOTO hang
ctgteok

;rem if var1 <> number then
;var1 = 70
 MOVLW 70
 MOVWF var1
;if var1 <> 70 then
 MOVLW 70
 SUBWF var1,0
 BTFSC 3,2
 GOTO ifnext__111
 GOTO hang
;else
 GOTO ifend__111
ifnext__111
; if var1 <> 69 then
 MOVLW 69
 SUBWF var1,0
 BTFSC 3,2
 GOTO ifnext__211
 GOTO ctneok
; endif
ifnext__211
;endif
ifend__111
 GOTO hang
ctneok

;rem if all tests ok...
;bitset outpin
 BSF outpin

hang
 GOTO hang

 end

